###
 Copyright 2014 Jan Svager

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
###
"use strict"

# JSX/Coffee live transform require
require('node-jsx').install extension: '.coffee', additionalTransform: (src) ->
  require('coffee-script').compile src

# Dependencies
express = require 'express'
path = require 'path'
url = require 'url'
react = require 'react'

# App init
app = express()
app.set 'config', require('./package.json').config
app.set 'port', app.get('config').port || process.env.PORT

# Development only
app.configure 'development', ->
  browserify = require 'connect-browserify'

  app.use express.static(path.join(__dirname, 'static')), null
  app.use express.logger('dev'), null
  app.use express.errorHandler(), null
  app.get '/bundle.js', browserify
    entry: './client.coffee'
    debug: true
    watch: true

# Production only
app.configure 'production', ->
  # static files -> nginx
  app.use express.logger('production'), null
  app.use express.compress(), null

# routes
app.get "/", (req, res) ->
  Client = require './client'
  res.send react.renderComponentToString Client(path: url.parse(req.url).pathname)

# Listen
app.listen app.get('port'), ->
  console.warn "Express server listening on port #{app.get('port')} in #{app.get 'env'}"

